Function LoadTrees(file$)
	tree=LoadMesh(file$)
	ScaleMesh tree,.1,.1,.1
	For n=1 To 500
		tree_copy=CopyEntity(tree)
		ScaleEntity tree_copy,Rand(1,4),Rand(1,4),Rand(1,4)
		x=Rand(-2000,2000)	:z=Rand(-2000,2000)
		PositionEntity tree_copy, x,TerrainY(land,x,0,z)-15,z
		RotateEntity tree_copy,0,Rand(1,180),0
		EntityAutoFade tree_copy,500,1000
	Next
	FreeEntity tree 	 
End Function

Function LoadDogs(file$)
	model=LoadAnimMesh(file$)
	ExtractAnimSeq model,2,14
	ScaleEntity model,.1,.1,.1
 
	For c=1 To 25
		Pack.dog = New dog
		Pack\ID = CopyEntity(model)
		x=Rand(-2000,2000):z=Rand(-2000,2000)
		PositionEntity Pack\ID, x,TerrainY(land,x,0,z),z
		Animate Pack\ID,1,.3,1
		EntityAutoFade Pack\ID,500,1000
	Next
	FreeEntity model
End Function

Function MoveDogs()
	For moveall.dog = Each dog
	If EntityDistance(moveall\ID,cam1)>10
		PointEntity moveall\ID,cam1
		MoveEntity moveall\ID,0,0,.5
		ex#=EntityX(moveall\ID):ez#=EntityZ(moveall\ID)
		PositionEntity moveall\ID,ex,TerrainY( land,ex,0,ez ),ez
	EndIf	
	Next
End Function

Function MakeWater(file$,wl)
	water_tex=LoadTexture(file$)
	ScaleTexture water_tex,20,20
	water=CreatePlane()
	EntityTexture water,water_tex
	PositionEntity water,0,wl,0
	EntityAlpha water,.5
End Function

Function MakeTerrain()
	land_tex=LoadTexture( "terrain_tex.jpg" )
	ScaleTexture land_tex,10,10
	land=LoadTerrain( "terrain_hmap.jpg" )
	ScaleEntity land,8,100,8
	PositionEntity land,-2048,0,-2048
	EntityTexture land,land_tex
	TerrainDetail land,1000,True
End Function

Function MakeSkybox()
	skybox=CreateMesh()
	;front face
	b=LoadBrush( "front.jpg",49 )
	s=CreateSurface( skybox,b )
	AddVertex s,-1,+1,-1,0,0:AddVertex s,+1,+1,-1,1,0
	AddVertex s,+1,-1,-1,1,1:AddVertex s,-1,-1,-1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;left face
	b=LoadBrush( "left.jpg",49 )
	s=CreateSurface( skybox,b )
	AddVertex s,+1,+1,-1,0,0:AddVertex s,+1,+1,+1,1,0
	AddVertex s,+1,-1,+1,1,1:AddVertex s,+1,-1,-1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;back face
	b=LoadBrush( "back.jpg",49 )
	s=CreateSurface( skybox,b )
	AddVertex s,+1,+1,+1,0,0:AddVertex s,-1,+1,+1,1,0
	AddVertex s,-1,-1,+1,1,1:AddVertex s,+1,-1,+1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;right face
	b=LoadBrush( "right.jpg",49 )
	s=CreateSurface( skybox,b )
	AddVertex s,-1,+1,+1,0,0:AddVertex s,-1,+1,-1,1,0
	AddVertex s,-1,-1,-1,1,1:AddVertex s,-1,-1,+1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;top face
	b=LoadBrush( "up.jpg",49 )
	s=CreateSurface( skybox,b )
	AddVertex s,-1,+1,+1,0,1:AddVertex s,+1,+1,+1,0,0
	AddVertex s,+1,+1,-1,1,0:AddVertex s,-1,+1,-1,1,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	;bottom face	
	b=LoadBrush( "down.jpg",49 )
	s=CreateSurface( skybox,b )
	AddVertex s,-1,-1,-1,1,0:AddVertex s,+1,-1,-1,1,1
	AddVertex s,+1,-1,+1,0,1:AddVertex s,-1,-1,+1,0,0
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	ScaleMesh skybox,100,100,100
	FlipMesh skybox
	EntityFX skybox,1
	EntityOrder skybox,10
End Function

Function object_key_control( obj )
	If KeyDown( 200 )=True Then MoveEntity obj,0,0,1
	If KeyDown( 208 )=True Then MoveEntity obj,0,0,-1
	If KeyDown( 203 )=True Then TurnEntity obj,0,2,0
	If KeyDown( 205 )=True Then TurnEntity obj,0,-2,0
	ex#=EntityX(obj):ez#=EntityZ(obj)
	PositionEntity obj,ex,TerrainY( land,ex,0,ez )+5,ez	
End Function 